Index: tags/autoquest-distribution-0.2.0/.classpath
===================================================================
--- tags/autoquest-distribution-0.2.0/.classpath	(revision 2084)
+++ tags/autoquest-distribution-0.2.0/.classpath	(revision 2084)
@@ -0,0 +1,5 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<classpath>
+	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
+	<classpathentry kind="output" path="target/classes"/>
+</classpath>
Index: tags/autoquest-distribution-0.2.0/.project
===================================================================
--- tags/autoquest-distribution-0.2.0/.project	(revision 2084)
+++ tags/autoquest-distribution-0.2.0/.project	(revision 2084)
@@ -0,0 +1,23 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>autoquest-distribution</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>org.eclipse.jdt.core.javabuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>org.eclipse.m2e.core.maven2Builder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>org.eclipse.m2e.core.maven2Nature</nature>
+		<nature>org.eclipse.jdt.core.javanature</nature>
+	</natures>
+</projectDescription>
Index: tags/autoquest-distribution-0.2.0/.settings/org.eclipse.m2e.core.prefs
===================================================================
--- tags/autoquest-distribution-0.2.0/.settings/org.eclipse.m2e.core.prefs	(revision 2084)
+++ tags/autoquest-distribution-0.2.0/.settings/org.eclipse.m2e.core.prefs	(revision 2084)
@@ -0,0 +1,4 @@
+activeProfiles=
+eclipse.preferences.version=1
+resolveWorkspaceProjects=true
+version=1
Index: tags/autoquest-distribution-0.2.0/pom.xml
===================================================================
--- tags/autoquest-distribution-0.2.0/pom.xml	(revision 2084)
+++ tags/autoquest-distribution-0.2.0/pom.xml	(revision 2084)
@@ -0,0 +1,249 @@
+<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
+  <parent>
+    <groupId>de.ugoe.cs.autoquest</groupId>
+    <artifactId>autoquest</artifactId>
+    <version>0.2.0</version>
+    <relativePath>../autoquest/pom.xml</relativePath>
+  </parent>
+  <modelVersion>4.0.0</modelVersion>
+  <artifactId>autoquest-distribution</artifactId>
+  <packaging>pom</packaging>
+  <name>autoquest-distribution</name>
+  <properties>
+    <autoquest-scm-trunk-dir>https://autoquest.informatik.uni-goettingen.de/svn/autoquest/trunk</autoquest-scm-trunk-dir>
+  </properties>
+  <scm>
+    <url>https://autoquest.informatik.uni-goettingen.de/svn/autoquest/tags/autoquest-distribution-0.2.0</url>
+    <connection>scm:svn:https://autoquest.informatik.uni-goettingen.de/svn/autoquest/tags/autoquest-distribution-0.2.0</connection>
+  </scm>
+
+  <modules>
+    <module>../java-utils</module>
+    <module>../autoquest</module>
+    <module>../autoquest-misc</module>
+    <module>../autoquest-core-events</module>
+    <module>../autoquest-core-assertions</module>
+    <module>../autoquest-core-coverage</module>
+    <module>../autoquest-core-usageprofiles</module>
+    <module>../autoquest-core-testgeneration</module>
+    <module>../autoquest-core-tasktrees</module>
+    <module>../autoquest-core-usability</module>
+    <module>../autoquest-ui-core</module>
+    <module>../autoquest-ui-swt</module>
+    <module>../autoquest-plugin-core</module>
+    <module>../autoquest-plugin-android</module>
+    <module>../autoquest-plugin-exports</module>
+    <module>../autoquest-plugin-guitar</module>
+    <module>../autoquest-plugin-html</module>
+    <module>../autoquest-plugin-http</module>
+    <module>../autoquest-plugin-jfc</module>
+    <module>../autoquest-plugin-mfc</module>
+    <module>../autoquest-plugin-php</module>
+    <module>../autoquest-plugin-uml</module>
+    <module>../autoquest-runner</module>
+  </modules>
+
+  <build>
+    <pluginManagement>
+      <plugins>
+        <plugin>
+          <groupId>org.eclipse.m2e</groupId>
+          <artifactId>lifecycle-mapping</artifactId>
+          <version>1.0.0</version>
+          <configuration>
+            <lifecycleMappingMetadata>
+              <pluginExecutions>
+                <pluginExecution>
+                  <pluginExecutionFilter>
+                    <groupId>org.apache.maven.plugins</groupId>
+                    <artifactId>maven-dependency-plugin</artifactId>
+                    <versionRange>[1.0.0,)</versionRange>
+                    <goals>
+                      <goal>get</goal>
+                    </goals>
+                  </pluginExecutionFilter>
+                  <action>
+                    <ignore />
+                  </action>
+                </pluginExecution>
+                <pluginExecution>
+                  <pluginExecutionFilter>
+                    <groupId>org.apache.maven.plugins</groupId>
+                    <artifactId>maven-dependency-plugin</artifactId>
+                    <versionRange>[1.0.0,)</versionRange>
+                    <goals>
+                      <goal>unpack</goal>
+                    </goals>
+                  </pluginExecutionFilter>
+                  <action>
+                    <ignore />
+                  </action>
+                </pluginExecution>
+              </pluginExecutions>
+            </lifecycleMappingMetadata>
+          </configuration>
+        </plugin>
+      </plugins>
+    </pluginManagement>
+    <plugins>
+      <plugin>
+        <groupId>org.apache.maven.plugins</groupId>
+        <artifactId>maven-dependency-plugin</artifactId>
+        <version>2.4</version>
+        <executions>
+          <execution>
+            <id>get-jfc-plugin-config</id>
+            <phase>process-classes</phase>
+            <goals>
+              <goal>unpack</goal>
+            </goals>
+            <configuration>
+              <artifactItems>
+                <artifactItem>
+                  <groupId>de.ugoe.cs.autoquest</groupId>
+                  <artifactId>autoquest-plugin-jfc</artifactId>
+                  <version>${project.parent.version}</version>
+                  <classifier>config</classifier>
+                  <type>zip</type>
+                  <outputDirectory>${project.build.directory}/data</outputDirectory>
+                </artifactItem>
+              </artifactItems>
+            </configuration>
+          </execution>
+          <execution>
+            <id>get-android-plugin-config</id>
+            <phase>process-classes</phase>
+            <goals>
+              <goal>unpack</goal>
+            </goals>
+            <configuration>
+              <artifactItems>
+                <artifactItem>
+                  <groupId>de.ugoe.cs.autoquest</groupId>
+                  <artifactId>autoquest-plugin-android</artifactId>
+                  <version>${project.parent.version}</version>
+                  <classifier>config</classifier>
+                  <type>zip</type>
+                  <outputDirectory>${project.build.directory}/data</outputDirectory>
+                </artifactItem>
+              </artifactItems>
+            </configuration>
+          </execution>
+          <execution>
+            <id>get-mfc-plugin-config</id>
+            <phase>process-classes</phase>
+            <goals>
+              <goal>unpack</goal>
+            </goals>
+            <configuration>
+              <artifactItems>
+                <artifactItem>
+                  <groupId>de.ugoe.cs.autoquest</groupId>
+                  <artifactId>autoquest-plugin-mfc</artifactId>
+                  <version>${project.parent.version}</version>
+                  <classifier>config</classifier>
+                  <type>zip</type>
+                  <outputDirectory>${project.build.directory}/data</outputDirectory>
+                </artifactItem>
+              </artifactItems>
+            </configuration>
+          </execution>
+          <execution>
+            <id>get-php-plugin-config</id>
+            <phase>process-classes</phase>
+            <goals>
+              <goal>unpack</goal>
+            </goals>
+            <configuration>
+              <artifactItems>
+                <artifactItem>
+                  <groupId>de.ugoe.cs.autoquest</groupId>
+                  <artifactId>autoquest-plugin-php</artifactId>
+                  <version>${project.parent.version}</version>
+                  <classifier>config</classifier>
+                  <type>zip</type>
+                  <outputDirectory>${project.build.directory}/data</outputDirectory>
+                </artifactItem>
+              </artifactItems>
+            </configuration>
+          </execution>
+          <execution>
+            <id>get-html-plugin-config</id>
+            <phase>process-classes</phase>
+            <goals>
+              <goal>unpack</goal>
+            </goals>
+            <configuration>
+              <artifactItems>
+                <artifactItem>
+                  <groupId>de.ugoe.cs.autoquest</groupId>
+                  <artifactId>autoquest-plugin-html</artifactId>
+                  <version>${project.parent.version}</version>
+                  <classifier>config</classifier>
+                  <type>zip</type>
+                  <outputDirectory>${project.build.directory}/data</outputDirectory>
+                </artifactItem>
+              </artifactItems>
+            </configuration>
+          </execution>
+          <execution>
+            <id>get-runner-bin-scripts</id>
+            <phase>process-classes</phase>
+            <goals>
+              <goal>unpack</goal>
+            </goals>
+            <configuration>
+              <artifactItems>
+                <artifactItem>
+                  <groupId>de.ugoe.cs.autoquest</groupId>
+                  <artifactId>autoquest-runner</artifactId>
+                  <version>${project.parent.version}</version>
+                  <classifier>bin</classifier>
+                  <type>zip</type>
+                  <outputDirectory>${project.build.directory}/bin</outputDirectory>
+                </artifactItem>
+              </artifactItems>
+            </configuration>
+          </execution>
+          <execution>
+            <id>get-runner-config</id>
+            <phase>process-classes</phase>
+            <goals>
+              <goal>unpack</goal>
+            </goals>
+            <configuration>
+              <artifactItems>
+                <artifactItem>
+                  <groupId>de.ugoe.cs.autoquest</groupId>
+                  <artifactId>autoquest-runner</artifactId>
+                  <version>${project.parent.version}</version>
+                  <classifier>config</classifier>
+                  <type>zip</type>
+                  <outputDirectory>${project.build.directory}/data</outputDirectory>
+                </artifactItem>
+              </artifactItems>
+            </configuration>
+          </execution>
+        </executions>
+      </plugin>
+      <plugin>
+        <artifactId>maven-assembly-plugin</artifactId>
+        <version>2.2-beta-1</version>
+        <configuration>
+          <descriptors>
+            <descriptor>src/main/assembly/bin.xml</descriptor>
+          </descriptors>
+        </configuration>
+        <executions>
+          <execution>
+            <id>make-assembly</id>
+            <phase>package</phase>
+            <goals>
+              <goal>single</goal>
+            </goals>
+          </execution>
+        </executions>
+      </plugin>
+    </plugins>
+  </build>
+</project>
Index: tags/autoquest-distribution-0.2.0/src/main/assembly/bin.xml
===================================================================
--- tags/autoquest-distribution-0.2.0/src/main/assembly/bin.xml	(revision 2084)
+++ tags/autoquest-distribution-0.2.0/src/main/assembly/bin.xml	(revision 2084)
@@ -0,0 +1,65 @@
+<assembly
+    xmlns="http://maven.apache.org/plugins/maven-assembly-plugin/assembly/1.1.2"
+    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+    xsi:schemaLocation="http://maven.apache.org/plugins/maven-assembly-plugin/assembly/1.1.2 http://maven.apache.org/xsd/assembly-1.1.2.xsd">
+  <id>bin</id>
+  <formats>
+    <format>tar.gz</format>
+    <format>dir</format>
+    <!--format>tar.bz2</format>
+    <format>zip</format-->
+  </formats>
+  <moduleSets>
+    <moduleSet>
+      <!-- add all dependencies except autoquest-runner into the lib directory -->
+      <!-- useAllReactorProjects>true</useAllReactorProjects-->
+      <includes></includes>
+      <excludes>
+        <exclude>de.ugoe.cs.autoquest:autoquest-runner</exclude>
+      </excludes>
+      <binaries>
+        <includes></includes>
+        <outputDirectory>lib</outputDirectory>
+        <unpack>false</unpack>
+      </binaries>
+    </moduleSet>
+    <moduleSet>
+      <!-- add only autoquest-runner to the main directory -->
+      <includes>
+          <include>de.ugoe.cs.autoquest:autoquest-runner</include>
+      </includes>
+      <binaries>
+        <includes></includes>
+        <outputDirectory></outputDirectory>
+        <unpack>false</unpack>
+        <dependencySets>
+          <dependencySet>
+            <excludes>
+              <exclude>de.ugoe.cs.autoquest*</exclude>
+              <exclude>org.eclipse.swt*</exclude>
+            </excludes>
+            <outputDirectory>lib</outputDirectory>
+            <unpack>false</unpack>
+          </dependencySet>
+        </dependencySets>
+      </binaries>
+    </moduleSet>
+  </moduleSets>
+  <fileSets>
+    <fileSet>
+      <directory>target/bin</directory>
+      <outputDirectory>bin</outputDirectory>
+      <fileMode>775</fileMode>
+      <includes>
+        <include>*</include>
+      </includes>
+    </fileSet>
+    <fileSet>
+      <directory>target/data</directory>
+      <outputDirectory>data</outputDirectory>
+      <excludes>
+        <exclude>META-INF/**</exclude>
+      </excludes>
+    </fileSet>
+  </fileSets>
+</assembly>