Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/guimodel/GUIElementTree.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/guimodel/GUIElementTree.java	(revision 2146)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/guimodel/GUIElementTree.java	(revision 2156)
@@ -15,11 +15,5 @@
 package de.ugoe.cs.autoquest.eventcore.guimodel;
 
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.List;
-import java.util.Map;
-
-import de.ugoe.cs.autoquest.eventcore.EventTargetModelException;
-import de.ugoe.cs.autoquest.eventcore.IEventTargetFactory;
+import de.ugoe.cs.autoquest.eventcore.HierarchicalEventTargetTree;
 import de.ugoe.cs.autoquest.eventcore.guimodel.GUIElementFactory;
 import de.ugoe.cs.autoquest.eventcore.guimodel.GUIModel;
@@ -40,50 +34,6 @@
  * @version 1.0
  */
-public class GUIElementTree<T> {
-    /**
-     * <p>
-     * Map of all GUI elements that are part of the tree for efficient searching. The keys of the
-     * map are the ids of the GUI elements.
-     * </p>
-     */
-    private Map<T, IGUIElement> guiElements;
-
-    /**
-     * <p>
-     * Map of all GUI element specifications that are part of the tree for efficient searching. The
-     * keys of the map are the ids of the GUI elements.
-     * </p>
-     */
-    private Map<T, IGUIElementSpec> guiElementSpecs;
-
-    /**
-     * <p>
-     * Map of all children of GUI elements that are part of the tree. The keys of the map are the
-     * ids of the parent GUI elements.
-     * </p>
-     */
-    private Map<T, List<T>> childRelations;
-
-    /**
-     * <p>
-     * Map of all parents of GUI elements that are part of the tree. The keys of the map are the
-     * ids of the child GUI elements.
-     * </p>
-     */
-    private Map<T, T> parentRelations;
-
-    /**
-     * <p>
-     * the internally created GUI model
-     * </p>
-     */
-    private GUIModel guiModel;
-
-    /**
-     * <p>
-     * the GUI element factory used in the model
-     * </p>
-     */
-    private IEventTargetFactory guiElementFactory = GUIElementFactory.getInstance();
+public class GUIElementTree<T> extends HierarchicalEventTargetTree<T, IGUIElement, IGUIElementSpec>
+{
 
     /**
@@ -93,9 +43,5 @@
      */
     public GUIElementTree() {
-        guiElementSpecs = new HashMap<T, IGUIElementSpec>();
-        childRelations = new HashMap<T, List<T>>();
-        parentRelations = new HashMap<T, T>();
-        guiElements = new HashMap<T, IGUIElement>();
-        guiModel = new GUIModel();
+        this(new GUIModel());
     }
     
@@ -107,152 +53,5 @@
      */
     public GUIElementTree(GUIModel guiModel){
-        guiElementSpecs = new HashMap<T, IGUIElementSpec>();
-        childRelations = new HashMap<T, List<T>>();
-        parentRelations = new HashMap<T, T>();
-        guiElements = new HashMap<T, IGUIElement>();
-        this.guiModel = guiModel;
-    }
-
-    /**
-     * <p>
-     * Adds a new GUI element to the tree.
-     * </p>
-     * 
-     * @param guiElementID
-     *            id of the GUI element to be created
-     * @param parentID
-     *            id of the parent GUI element 
-     * @param guiElementSpec
-     *            the GUI element specification
-     *            
-     * @throws EventTargetModelException if the GUI element can not be added to the underlying GUI model
-     */
-    public void add(T guiElementID,
-                    T parentID,
-                    IGUIElementSpec guiElementSpec)
-        throws EventTargetModelException
-    {
-        IGUIElement guiElement = guiElements.get(guiElementID);
-        
-        if (guiElement == null) {
-            IGUIElementSpec parent = guiElementSpecs.get(parentID);
-            if (parent != null) {
-                List<T> otherChildren = childRelations.get(parentID);
-
-                if (otherChildren == null) {
-                    otherChildren = new ArrayList<T>();
-                    childRelations.put(parentID, otherChildren);
-                }
-
-                otherChildren.add(guiElementID);
-
-                parentRelations.put(guiElementID, parentID);
-            }
-            guiElementSpecs.put(guiElementID, guiElementSpec);
-            
-            List<IGUIElementSpec> guiElementPath = new ArrayList<IGUIElementSpec>();
-
-            T currentElementID = guiElementID;
-            while (guiElementSpec != null) {
-                guiElementPath.add(0, guiElementSpec);
-                currentElementID = parentRelations.get(currentElementID);
-                guiElementSpec = guiElementSpecs.get(currentElementID);
-            }
-
-            guiElement = (IGUIElement) guiModel.integratePath(guiElementPath, guiElementFactory);
-            guiElements.put(guiElementID, guiElement);
-        }
-    }
-
-    /**
-     * <p>
-     * Searches the tree for a GUI element with the specified id and returns its
-     * {@link IGUIElement} .
-     * </p>
-     * 
-     * @param id
-     *            id that is looked for
-     * @return {@link IGUIElementSpec} of the GUI element with the given id if found, null otherwise
-     */
-    public IGUIElement find(T id) {
-        return guiElements.get(id);
-    }
-
-    /**
-     * <p>
-     * Returns the id of the provided {@link IGUIElement}. The comparison is performed using the
-     * equals method of the GUI element.
-     * </p>
-     * 
-     * @param guiElement
-     *            guiElement that is looked for
-     * @return the id of the GUI element, null if the GUI element can not be found
-     */
-    public T find(IGUIElement guiElement) {
-        for (Map.Entry<T, IGUIElement> entry : guiElements.entrySet()) {
-            if (guiElement.equals(entry.getValue())) {
-                return entry.getKey();
-            }
-        }
-        
-        return null;
-    }
-
-    /**
-     * <p>
-     * Removes a GUI element (defined by its id) from the tree. All children of the GUI element will be
-     * removed recursively.
-     * </p>
-     * 
-     * @param id
-     *            id of the GUI element to be removed
-     * @return number of GUI elements that were removed
-     */
-    public int remove(T id) {
-        int removedCounter = 0;
-        IGUIElementSpec node = guiElementSpecs.remove(id);
-
-        if (node != null) {
-            removedCounter++;
-            List<T> nodesToBeRemoved = childRelations.remove(id);
-
-            // remove all children and sub-children, if any
-            if (nodesToBeRemoved != null) {
-                for (int i = 0; i < nodesToBeRemoved.size(); i++) {
-                    T nodeToBeRemoved = nodesToBeRemoved.get(i);
-                    List<T> children =
-                        childRelations.remove(nodeToBeRemoved);
-
-                    if (children != null) {
-                        nodesToBeRemoved.addAll(children);
-                    }
-
-                    guiElementSpecs.remove(nodeToBeRemoved);
-                    parentRelations.remove(nodeToBeRemoved);
-                    removedCounter++;
-                }
-            }
-
-            /* the node may be a child node of a parent. So search for it in the child relations
-            of the parent and remove it */
-            T parent = parentRelations.remove(id);
-            if (parent != null) {
-                List<T> children = childRelations.get(parent);
-
-                if (children != null) {
-                    for (int i = 0; i < children.size(); i++) {
-                        if (children.get(i) == id) {
-                            children.remove(i);
-                            break;
-                        }
-                    }
-
-                    if (children.size() <= 0) {
-                        childRelations.remove(parent);
-                    }
-                }
-            }
-        }
-        return removedCounter;
+        super(guiModel, GUIElementFactory.getInstance());
     }
 
@@ -261,16 +60,5 @@
      */
     public GUIModel getGUIModel() {
-        return guiModel;
-    }
-
-    /**
-     * <p>
-     * Returns the number of nodes contained in the JFCComponentTree.
-     * </p>
-     * 
-     * @return number of nodes
-     */
-    public int size() {
-        return guiElementSpecs.size();
+        return (GUIModel) super.getHierarchicalEventTargetModel();
     }
 