Index: trunk/autoquest-core-usability-test/src/test/java/de/ugoe/cs/autoquest/usability/CommonTaskRateRuleTest.java
===================================================================
--- trunk/autoquest-core-usability-test/src/test/java/de/ugoe/cs/autoquest/usability/CommonTaskRateRuleTest.java	(revision 2120)
+++ trunk/autoquest-core-usability-test/src/test/java/de/ugoe/cs/autoquest/usability/CommonTaskRateRuleTest.java	(revision 2169)
@@ -79,5 +79,6 @@
         // smell expected, as for each action a different root node exists
         UsabilitySmell[] expectedSmells = new UsabilitySmell[]
-            { new UsabilitySmell(UsabilitySmellIntensity.getIntensity(0), COMMON_TASK_RATE) };
+            { new UsabilitySmell(UsabilitySmellIntensity.getIntensity(0), COMMON_TASK_RATE),
+              new UsabilitySmell(UsabilitySmellIntensity.getIntensity(0), COMMON_TASK_RATE) };
 
         assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
@@ -128,5 +129,6 @@
         // smell expected, as for each action a different root node exists
         UsabilitySmell[] expectedSmells = new UsabilitySmell[]
-            { new UsabilitySmell(UsabilitySmellIntensity.getIntensity(0), COMMON_TASK_RATE) };
+            { new UsabilitySmell(UsabilitySmellIntensity.getIntensity(0), COMMON_TASK_RATE),
+              new UsabilitySmell(UsabilitySmellIntensity.getIntensity(0), COMMON_TASK_RATE) };
 
         assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
@@ -175,5 +177,6 @@
         // smell expected, as for many actions a different root node exists
         UsabilitySmell[] expectedSmells = new UsabilitySmell[]
-            { new UsabilitySmell(UsabilitySmellIntensity.getIntensity(0), COMMON_TASK_RATE) };
+            { new UsabilitySmell(UsabilitySmellIntensity.getIntensity(0), COMMON_TASK_RATE),
+              new UsabilitySmell(UsabilitySmellIntensity.getIntensity(0), COMMON_TASK_RATE) };
 
         assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
@@ -222,5 +225,6 @@
         // smell expected, as for many actions a different root node exists
         UsabilitySmell[] expectedSmells = new UsabilitySmell[]
-            { new UsabilitySmell(UsabilitySmellIntensity.getIntensity(0), COMMON_TASK_RATE) };
+            { new UsabilitySmell(UsabilitySmellIntensity.getIntensity(0), COMMON_TASK_RATE),
+              new UsabilitySmell(UsabilitySmellIntensity.getIntensity(0), COMMON_TASK_RATE) };
 
         assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
Index: trunk/autoquest-core-usability-test/src/test/java/de/ugoe/cs/autoquest/usability/RequiredInefficientActionsRuleTest.java
===================================================================
--- trunk/autoquest-core-usability-test/src/test/java/de/ugoe/cs/autoquest/usability/RequiredInefficientActionsRuleTest.java	(revision 2120)
+++ trunk/autoquest-core-usability-test/src/test/java/de/ugoe/cs/autoquest/usability/RequiredInefficientActionsRuleTest.java	(revision 2169)
@@ -90,4 +90,5 @@
             "UserSession {" +
             "  Sequence {" +
+            "    Interaction elem1 {}" +
             "    Scroll body {}" +
             "    Interaction elem1 {}" +
@@ -115,4 +116,5 @@
             "  Sequence {" +
             "    Interaction elem1 {}" +
+            "    Interaction elem2 {}" +
             "    Scroll body {}" +
             "  }" +
@@ -140,8 +142,10 @@
             "    Scroll body {}" +
             "    Interaction elem1 {}" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Scroll body {}" +
-            "    Interaction elem1 {}" +
+            "    Interaction elem2 {}" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Scroll body {}" +
+            "    Interaction elem1 {}" +
+            "    Interaction elem2 {}" +
             "  }" +
             "}";
@@ -168,8 +172,10 @@
             "    Interaction elem1 {}" +
             "    Scroll body {}" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Interaction elem1 {}" +
-            "    Scroll body {}" +
+            "    Interaction elem2 {}" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Interaction elem1 {}" +
+            "    Scroll body {}" +
+            "    Interaction elem2 {}" +
             "  }" +
             "}";
@@ -223,16 +229,19 @@
             "    Optional opt1 { }" +
             "    Interaction elem1 {}" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Optional opt1 {" +
-            "      Scroll body {}" +
-            "    }" +
-            "    Interaction elem1 {}" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Optional opt1 {" +
-            "      Scroll body {}" +
-            "    }" +
-            "    Interaction elem1 {}" +
+            "    Interaction elem2 {}" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Optional opt1 {" +
+            "      Scroll body {}" +
+            "    }" +
+            "    Interaction elem1 {}" +
+            "    Interaction elem2 {}" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Optional opt1 {" +
+            "      Scroll body {}" +
+            "    }" +
+            "    Interaction elem1 {}" +
+            "    Interaction elem2 {}" +
             "  }" +
             "}";
@@ -258,14 +267,17 @@
             "  Sequence seq1 {" +
             "    Interaction elem1 {}" +
-            "    Optional opt1 { }" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Interaction elem1 {}" +
-            "    Optional opt1 {" +
-            "      Scroll body {}" +
-            "    }" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Interaction elem1 {}" +
+            "    Interaction elem2 {}" +
+            "    Optional opt1 { }" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Interaction elem1 {}" +
+            "    Interaction elem2 {}" +
+            "    Optional opt1 {" +
+            "      Scroll body {}" +
+            "    }" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Interaction elem1 {}" +
+            "    Interaction elem2 {}" +
             "    Optional opt1 {" +
             "      Scroll body {}" +
@@ -293,18 +305,22 @@
             "UserSession {" +
             "  Sequence seq1 {" +
-            "    Optional opt1 { }" +
-            "    Interaction elem1 {}" +
-            "  }" +
-            "  Sequence seq1 {" +
+            "    Interaction elem2 {}" +
+            "    Optional opt1 { }" +
+            "    Interaction elem1 {}" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Interaction elem2 {}" +
             "    Optional opt1 {}" +
             "    Interaction elem1 {}" +
             "  }" +
             "  Sequence seq1 {" +
-            "    Optional opt1 {" +
-            "      Scroll body {}" +
-            "    }" +
-            "    Interaction elem1 {}" +
-            "  }" +
-            "  Sequence seq1 {" +
+            "    Interaction elem2 {}" +
+            "    Optional opt1 {" +
+            "      Scroll body {}" +
+            "    }" +
+            "    Interaction elem1 {}" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Interaction elem2 {}" +
             "    Optional opt1 {" +
             "      Scroll body {}" +
@@ -335,20 +351,24 @@
             "    Interaction elem1 {}" +
             "    Optional opt1 { }" +
+            "    Interaction elem2 {}" +
             "  }" +
             "  Sequence seq1 {" +
             "    Interaction elem1 {}" +
             "    Optional opt1 {}" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Interaction elem1 {}" +
-            "    Optional opt1 {" +
-            "      Scroll body {}" +
-            "    }" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Interaction elem1 {}" +
-            "    Optional opt1 {" +
-            "      Scroll body {}" +
-            "    }" +
+            "    Interaction elem2 {}" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Interaction elem1 {}" +
+            "    Optional opt1 {" +
+            "      Scroll body {}" +
+            "    }" +
+            "    Interaction elem2 {}" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Interaction elem1 {}" +
+            "    Optional opt1 {" +
+            "      Scroll body {}" +
+            "    }" +
+            "    Interaction elem2 {}" +
             "  }" +
             "}";
@@ -375,18 +395,22 @@
             "    Optional opt1 { }" +
             "    Interaction elem1 {}" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Optional opt1 { }" +
-            "    Interaction elem1 {}" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Optional opt1 { }" +
-            "    Interaction elem1 {}" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Optional opt1 {" +
-            "      Scroll body {}" +
-            "    }" +
-            "    Interaction elem1 {}" +
+            "    Interaction elem2 {}" +
+           "  }" +
+            "  Sequence seq1 {" +
+            "    Optional opt1 { }" +
+            "    Interaction elem1 {}" +
+            "    Interaction elem2 {}" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Optional opt1 { }" +
+            "    Interaction elem1 {}" +
+            "    Interaction elem2 {}" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Optional opt1 {" +
+            "      Scroll body {}" +
+            "    }" +
+            "    Interaction elem1 {}" +
+            "    Interaction elem2 {}" +
             "  }" +
             "}";
@@ -413,18 +437,22 @@
             "    Interaction elem1 {}" +
             "    Optional opt1 { }" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Interaction elem1 {}" +
-            "    Optional opt1 { }" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Interaction elem1 {}" +
-            "    Optional opt1 { }" +
-            "  }" +
-            "  Sequence seq1 {" +
-            "    Interaction elem1 {}" +
-            "    Optional opt1 {" +
-            "      Scroll body {}" +
-            "    }" +
+            "    Interaction elem2 {}" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Interaction elem1 {}" +
+            "    Optional opt1 { }" +
+            "    Interaction elem2 {}" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Interaction elem1 {}" +
+            "    Optional opt1 { }" +
+            "    Interaction elem2 {}" +
+            "  }" +
+            "  Sequence seq1 {" +
+            "    Interaction elem1 {}" +
+            "    Optional opt1 {" +
+            "      Scroll body {}" +
+            "    }" +
+            "    Interaction elem2 {}" +
             "  }" +
             "}";
@@ -486,5 +514,5 @@
         UsabilitySmell[] expectedSmells = new UsabilitySmell[] { };
 
-        //assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }
@@ -538,5 +566,5 @@
         UsabilitySmell[] expectedSmells = new UsabilitySmell[] { };
 
-        //assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
+        assertUsabilityEvaluationResult(expectedSmells, rule.evaluate(createTaskModel(spec)));
 
     }