Index: trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDcorrectDirOldJFC.java
===================================================================
--- trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDcorrectDirOldJFC.java	(revision 2035)
+++ trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDcorrectDirOldJFC.java	(revision 2233)
@@ -69,10 +69,14 @@
         String absolutPath = folder.getAbsolutePath();
         String absolutDestPath = destfolder.getAbsolutePath();
-        for (String filename : folder.list()) {
-            String source = absolutPath + "/" + filename;
-            String dest = absolutDestPath + "/" + filename;
-            Console.traceln(Level.INFO, "Processing file: " + source);
+        String[] children = folder.list();
+        
+        if (children != null) {
+            for (String filename : folder.list()) {
+                String source = absolutPath + "/" + filename;
+                String dest = absolutDestPath + "/" + filename;
+                Console.traceln(Level.INFO, "Processing file: " + source);
 
-            corrector.correctFile(source, dest);
+                corrector.correctFile(source, dest);
+            }
         }
     }
Index: trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDparseDirJFC.java
===================================================================
--- trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDparseDirJFC.java	(revision 2035)
+++ trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDparseDirJFC.java	(revision 2233)
@@ -69,14 +69,18 @@
 
         String absolutPath = folder.getAbsolutePath();
-        for (String filename : folder.list()) {
-            String source = absolutPath + File.separator + filename;
-            Console.traceln(Level.INFO, "Processing file: " + source);
+        String[] children = folder.list();
+        
+        if (children != null) {
+        	for (String filename : children) {
+        		String source = absolutPath + File.separator + filename;
+        		Console.traceln(Level.INFO, "Processing file: " + source);
 
-            try {
-                parser.parseFile(source);
-            }
-            catch (Exception e) {
-                Console.printerrln("Could not parse " + source + ": " + e.getMessage());
-            }
+        		try {
+        			parser.parseFile(source);
+        		}
+        		catch (Exception e) {
+        			Console.printerrln("Could not parse " + source + ": " + e.getMessage());
+        		}
+        	}
         }
 
Index: trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDparseDirOldJFC.java
===================================================================
--- trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDparseDirOldJFC.java	(revision 2035)
+++ trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDparseDirOldJFC.java	(revision 2233)
@@ -69,13 +69,17 @@
 
         String absolutPath = folder.getAbsolutePath();
-        for (String filename : folder.list()) {
-            String source = absolutPath + File.separator + filename;
-            Console.traceln(Level.INFO, "Processing file: " + source);
+        String[] children = folder.list();
+        
+        if (children != null) {
+            for (String filename : children) {
+            	String source = absolutPath + File.separator + filename;
+            	Console.traceln(Level.INFO, "Processing file: " + source);
 
-            try {
-                parser.parseFile(source);
-            }
-            catch (Exception e) {
-                Console.printerrln("Could not parse " + source + ": " + e.getMessage());
+            	try {
+            		parser.parseFile(source);
+            	}
+            	catch (Exception e) {
+            		Console.printerrln("Could not parse " + source + ": " + e.getMessage());
+            	}
             }
         }
Index: trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDparseJFCDirwithJacaretoIndices.java
===================================================================
--- trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDparseJFCDirwithJacaretoIndices.java	(revision 2035)
+++ trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDparseJFCDirwithJacaretoIndices.java	(revision 2233)
@@ -83,13 +83,17 @@
 
         String absolutPath = folder.getAbsolutePath();
-        for (String filename : folder.list()) {
-            String source = absolutPath + File.separator + filename;
-            Console.traceln(Level.INFO, "Processing file: " + source);
-
-            try {
-                parser.parseFile(source);
-            }
-            catch (Exception e) {
-                Console.printerrln("Could not parse " + source + ": " + e.getMessage());
+        String[] children = folder.list();
+        
+        if (children != null) {
+            for (String filename : children) {
+            	String source = absolutPath + File.separator + filename;
+            	Console.traceln(Level.INFO, "Processing file: " + source);
+
+            	try {
+            		parser.parseFile(source);
+            	}
+            	catch (Exception e) {
+            		Console.printerrln("Could not parse " + source + ": " + e.getMessage());
+            	}
             }
         }
Index: trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDpreprocessDirJFC.java
===================================================================
--- trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDpreprocessDirJFC.java	(revision 2035)
+++ trunk/autoquest-plugin-jfc/src/main/java/de/ugoe/cs/autoquest/plugin/jfc/commands/CMDpreprocessDirJFC.java	(revision 2233)
@@ -69,53 +69,57 @@
 		String absolutPathTarget = targetFolder.getAbsolutePath();
 
-		for (String filename : sourceFolder.list()) {
-			String source = absolutPathSource + "/" + filename;
-			Console.traceln(Level.INFO, "Preprocessing file: " + source);
-			File file = new File(source);
-			InputStreamReader reader;
-			try {
-				FileInputStream fis = new FileInputStream(file);
-				reader = new InputStreamReader(fis, "UTF-16");
-			} catch (FileNotFoundException e) {
-				Console.printerrln(e.getMessage());
-				return;
-			} catch (UnsupportedEncodingException e) {
-				Console.printerrln(e.getMessage());
-				return;
-			}
-			char[] buffer = new char[(int) file.length()];
-			try {
-				reader.read(buffer);
-				reader.close();
-			} catch (IOException e) {
-				Console.printerrln(e.getMessage());
-				return;
-			}
+        String[] children = sourceFolder.list();
+        
+        if (children != null) {
+    		for (String filename : children) {
+    			String source = absolutPathSource + "/" + filename;
+    			Console.traceln(Level.INFO, "Preprocessing file: " + source);
+    			File file = new File(source);
+    			InputStreamReader reader;
+    			try {
+    				FileInputStream fis = new FileInputStream(file);
+    				reader = new InputStreamReader(fis, "UTF-16");
+    			} catch (FileNotFoundException e) {
+    				Console.printerrln(e.getMessage());
+    				return;
+    			} catch (UnsupportedEncodingException e) {
+    				Console.printerrln(e.getMessage());
+    				return;
+    			}
+    			char[] buffer = new char[(int) file.length()];
+    			try {
+    				reader.read(buffer);
+    				reader.close();
+    			} catch (IOException e) {
+    				Console.printerrln(e.getMessage());
+    				return;
+    			}
 
-			String content = new String(buffer).trim();
+    			String content = new String(buffer).trim();
 
-			int index = filename.lastIndexOf('.');
-			String target = absolutPathTarget + "/"
-					+ filename.substring(0, index) + ".xml";
+    			int index = filename.lastIndexOf('.');
+    			String target = absolutPathTarget + "/"
+    					+ filename.substring(0, index) + ".xml";
 
-			Console.traceln(Level.INFO, "   Saving as: " + target);
+    			Console.traceln(Level.INFO, "   Saving as: " + target);
 
-			OutputStreamWriter writer;
-			try {
-				FileOutputStream fos = new FileOutputStream(target);
-				writer = new OutputStreamWriter(fos, "UTF-8");
-			} catch (IOException e) {
-				Console.printerrln(e.getMessage());
-				return;
-			}
-			try {
-				writer.write(content);
-				if (!content.endsWith("</sessions>")) {
-					writer.write("</sessions>");
-				}
-				writer.close();
-			} catch (IOException e) {
-				Console.printerrln(e.getMessage());
-			}
+    			OutputStreamWriter writer;
+    			try {
+    				FileOutputStream fos = new FileOutputStream(target);
+    				writer = new OutputStreamWriter(fos, "UTF-8");
+    			} catch (IOException e) {
+    				Console.printerrln(e.getMessage());
+    				return;
+    			}
+    			try {
+    				writer.write(content);
+    				if (!content.endsWith("</sessions>")) {
+    					writer.write("</sessions>");
+    				}
+    				writer.close();
+    			} catch (IOException e) {
+    				Console.printerrln(e.getMessage());
+    			}
+    		}
 		}
 	}