Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/IInteraction.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/IInteraction.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/IInteraction.java	(revision 2254)
@@ -27,21 +27,4 @@
  */
 public interface IInteraction extends IEventType {
-    /**
-     * <p>
-     * Determines whether an event type starts a logical sequence, i.e., a task.
-     * </p>
-     * 
-     * @return true if a logical sequence is started; false otherwise
-     */
-    public boolean startsLogicalSequence();
-
-    /**
-     * <p>
-     * Determines whether an event type finishes a logical sequence, i.e., a task.
-     * </p>
-     * 
-     * @return true if a logical sequence is finished; false otherwise
-     */
-    public boolean finishesLogicalSequence();
 
 }
Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/KeyPressed.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/KeyPressed.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/KeyPressed.java	(revision 2254)
@@ -67,23 +67,4 @@
      * (non-Javadoc)
      * 
-     * @see de.harms.attef.userinteraction.Interaction#startsLogicalSequence()
-     */
-    public boolean startsLogicalSequence() {
-        // TODO handle lock keys correctly
-        return super.getKey().isCombinationKey();
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.harms.attef.userinteraction.Interaction#finishesLogicalSequence()
-     */
-    public boolean finishesLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
      * @see java.lang.Object#equals(java.lang.Object)
      */
Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/KeyReleased.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/KeyReleased.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/KeyReleased.java	(revision 2254)
@@ -67,23 +67,4 @@
      * (non-Javadoc)
      * 
-     * @see de.harms.attef.userinteraction.Interaction#startsLogicalSequence()
-     */
-    public boolean startsLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.harms.attef.userinteraction.Interaction#finishesLogicalSequence()
-     */
-    public boolean finishesLogicalSequence() {
-        // TODO handle lock keys correctly
-        return super.getKey().isCombinationKey();
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
      * @see java.lang.Object#equals(java.lang.Object)
      */
Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/KeyTyped.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/KeyTyped.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/KeyTyped.java	(revision 2254)
@@ -67,24 +67,4 @@
      * (non-Javadoc)
      * 
-     * @see de.harms.attef.userinteraction.Interaction#startsLogicalSequence()
-     */
-    public boolean startsLogicalSequence() {
-        // TODO handle lock keys correctly
-        return super.getKey().isCombinationKey();
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.harms.attef.userinteraction.Interaction#finishesLogicalSequence()
-     */
-    public boolean finishesLogicalSequence() {
-        // TODO handle lock keys correctly
-        return super.getKey().isCombinationKey();
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
      * @see java.lang.Object#equals(java.lang.Object)
      */
Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/KeyboardFocusChange.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/KeyboardFocusChange.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/KeyboardFocusChange.java	(revision 2254)
@@ -45,24 +45,4 @@
      * (non-Javadoc)
      * 
-     * @see de.ugoe.cs.tasktree.userinteraction.Interaction#startsLogicalSequence()
-     */
-    @Override
-    public boolean startsLogicalSequence() {
-        return true;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.ugoe.cs.tasktree.userinteraction.Interaction#finishesLogicalSequence()
-     */
-    @Override
-    public boolean finishesLogicalSequence() {
-        return true;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
      * @see java.lang.Object#toString()
      */
Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseButtonDown.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseButtonDown.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseButtonDown.java	(revision 2254)
@@ -87,22 +87,4 @@
      * (non-Javadoc)
      * 
-     * @see de.harms.attef.userinteraction.Interaction#startsLogicalSequence()
-     */
-    public boolean startsLogicalSequence() {
-        return true;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.harms.attef.userinteraction.Interaction#finishesLogicalSequence()
-     */
-    public boolean finishesLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
      * @see java.lang.Object#equals(java.lang.Object)
      */
Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseButtonUp.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseButtonUp.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseButtonUp.java	(revision 2254)
@@ -87,22 +87,4 @@
      * (non-Javadoc)
      * 
-     * @see de.harms.attef.userinteraction.Interaction#startsLogicalSequence()
-     */
-    public boolean startsLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.harms.attef.userinteraction.Interaction#finishesLogicalSequence()
-     */
-    public boolean finishesLogicalSequence() {
-        return true;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
      * @see java.lang.Object#equals(java.lang.Object)
      */
Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseClick.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseClick.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseClick.java	(revision 2254)
@@ -87,22 +87,4 @@
      * (non-Javadoc)
      * 
-     * @see de.harms.attef.userinteraction.Interaction#startsLogicalSequence()
-     */
-    public boolean startsLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.harms.attef.userinteraction.Interaction#finishesLogicalSequence()
-     */
-    public boolean finishesLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
      * @see java.lang.Object#equals(java.lang.Object)
      */
Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseDoubleClick.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseDoubleClick.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseDoubleClick.java	(revision 2254)
@@ -88,22 +88,4 @@
      * (non-Javadoc)
      * 
-     * @see de.harms.attef.userinteraction.Interaction#startsLogicalSequence()
-     */
-    public boolean startsLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.harms.attef.userinteraction.Interaction#finishesLogicalSequence()
-     */
-    public boolean finishesLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
      * @see java.lang.Object#equals(java.lang.Object)
      */
Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseDragAndDrop.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseDragAndDrop.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/MouseDragAndDrop.java	(revision 2254)
@@ -104,22 +104,4 @@
      * (non-Javadoc)
      * 
-     * @see de.harms.attef.userinteraction.Interaction#startsLogicalSequence()
-     */
-    public boolean startsLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.harms.attef.userinteraction.Interaction#finishesLogicalSequence()
-     */
-    public boolean finishesLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
      * @see java.lang.Object#equals(java.lang.Object)
      */
Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/Scroll.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/Scroll.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/Scroll.java	(revision 2254)
@@ -68,24 +68,4 @@
     }
 
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.ugoe.cs.tasktree.userinteraction.Interaction#startsLogicalSequence()
-     */
-    @Override
-    public boolean startsLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.ugoe.cs.tasktree.userinteraction.Interaction#finishesLogicalSequence()
-     */
-    @Override
-    public boolean finishesLogicalSequence() {
-        return false;
-    }
-
     /**
      * @return the position
Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/TextInput.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/TextInput.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/TextInput.java	(revision 2254)
@@ -173,22 +173,4 @@
      * (non-Javadoc)
      * 
-     * @see de.harms.attef.userinteraction.Interaction#startsLogicalSequence()
-     */
-    public boolean startsLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.harms.attef.userinteraction.Interaction#finishesLogicalSequence()
-     */
-    public boolean finishesLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
      * @see java.lang.Object#equals(java.lang.Object)
      */
Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/TextSelection.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/TextSelection.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/TextSelection.java	(revision 2254)
@@ -54,22 +54,4 @@
      * (non-Javadoc)
      * 
-     * @see de.harms.attef.userinteraction.Interaction#startsLogicalSequence()
-     */
-    public boolean startsLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.harms.attef.userinteraction.Interaction#finishesLogicalSequence()
-     */
-    public boolean finishesLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
      * @see java.lang.Object#equals(java.lang.Object)
      */
Index: trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/ValueSelection.java
===================================================================
--- trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/ValueSelection.java	(revision 2252)
+++ trunk/autoquest-core-events/src/main/java/de/ugoe/cs/autoquest/eventcore/gui/ValueSelection.java	(revision 2254)
@@ -82,22 +82,4 @@
     }
 
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.harms.attef.userinteraction.Interaction#startsLogicalSequence()
-     */
-    public boolean startsLogicalSequence() {
-        return false;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
-     * @see de.harms.attef.userinteraction.Interaction#finishesLogicalSequence()
-     */
-    public boolean finishesLogicalSequence() {
-        return false;
-    }
-
     /**
      * <p>